/**
 * Copyright uwi ( http://wonderfl.net/user/uwi )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/j076
 */

package {

import flash.display.*;
import flash.geom.*;
import flash.events.*;
import flash.text.*;
import flash.utils.*;

public class Main extends Sprite
{
    static private const N:uint = 1000;
    static private const M:uint = 300;
    
    // LinkedListはindex指定でremoveすると遅そうなので、インデックス0だけremoveがりがりにしてみました。
    private function _init():void
    {
        _debug(
            "各テスト " + N + " 回処理させた計算結果 [単位 ： ミリ秒]\n" +
            "(誤差は多少生じます)\n"
        );
        
        
        _measure("push", function ():void
        {
            for (var i:uint = 0; i < N; i++) {
                var a : Array = [];
                var k : int;
                for(k = 0;k < M;k++){
                    a.push(i);
                }
            }
        });
        
        _measure("push+splice", function ():void
        {
            for (var i:uint = 0; i < N; i++) {
                var a : Array = [];
                var k : int;
                for(k = 0;k < M;k++){
                    a.push(i);
                }
                for(k = 0;k < M;k++){
//                    a.splice(Math.random() * a.length, 1);
                    a.splice(0, 1);
                } 
            }
        });
        
        _measure("push+swap", function ():void
        {
            for (var i:uint = 0; i < N; i++) {
                var a : Array = [];
                var k : int;
                for(k = 0;k < M;k++){
                    a.push(i);
                }
//                var ind : int;
                for(k = 0;k < M;k++){
//                    ind = Math.random() * (M - k);
//                    a[ind] = a[a.length - 1];
                    a[0] = a[a.length - 1];
//                    a[a.length - 1] = null;
                } 
            }
        });
        
        _measure("linkedpush", function ():void
        {
            for (var i:uint = 0; i < N; i++) {
                var t : Object = {val : 0};
                var a : Object = t;
                var k : int;
                for(k = 1;k < M;k++){
                    a = a.next = {val : k};
                }
            }
        }); 
        
        _measure("linkedpush+remove", function ():void
        {
            for (var i:uint = 0; i < N; i++) {
                var t : Object = {val : 0};
                var a : Object = t;
                var k : int;
                for(k = 1;k < M;k++){
                    a = a.next = {val : k};
                }
                
//                t.next = t.next.next;
                for(k = 1;k < M;k++){
                    t = t.next;
                }
            }
        }); 
        
        // おまけ
        _measure("push+shift", function ():void
        {
            for (var i:uint = 0; i < N; i++) {
                var a : Array = [];
                var k : int;
                for(k = 0;k < M;k++){
                    a.push(i);
                }
                for(k = 0;k < M;k++){
                    a.shift();
                } 
            }
        });
        
        
        _debug("\n結果については言及しませんので, 各自ご判断ください.");
    }
    
    private var _field:TextField;
    private var _time:uint;
    
    public function Main():void
    {
        _setup();
        _init();
    }
    
    private function _measure(title:String, func:Function, ...params):void
    {
        _time = getTimer();
        func.apply(null, params);
        _time = getTimer() - _time;
        
        _debug("[ " + title + " ] --> " + _time + " ms");
    }
    
    private function _debug(log:String):void
    {
        _field.appendText(log + "\n");
    }
    
    private function _setup():void
    {
        _field = new TextField();
        _field.width = stage.stageWidth - 40;
        _field.height = stage.stageHeight - 60;
        _field.x = 20;
        _field.y = 60;
        _field.multiline = true;
        _field.wordWrap = true;
        
        var format:TextFormat = _field.defaultTextFormat;
        format.font = "_sans";
        _field.defaultTextFormat = format;
        
        addChild(_field);
        
        var button:Sprite = new Sprite();
        button.graphics.lineStyle(1, 0xBBBBBB);
        button.graphics.beginFill(0xEEEEEE);
        button.graphics.drawRoundRect(0, 0, 100, 20, 5, 5);
        button.graphics.endFill();
        
        addChild(button);
        
        button.x = 20;
        button.y = 20;
        button.mouseChildren = false;
        button.buttonMode = true;
        
        var field:TextField = new TextField();
        field.width = 100;
        field.height = 20;
        field.htmlText = "<p align='center'><font face='_sans'>再計算</span></p>";
        
        button.addChild(field);
        
        button.addEventListener(MouseEvent.CLICK, function ():void
        {
            _field.text = "";
            _init();
        });
    }
}

}
